#include "ch32v30x.h"
#include "FreeRTOS.h"
#include "task.h"
#include "debug.h"

TaskHandle_t hTaskBlink;

void GPIO_User_Init(void);

void TaskBlink(void* pArgs);

void main(void) {
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    GPIO_User_Init();
    USART_Printf_Init(115200);

    printf("\nMCU: CH32V307VCT6\n");
    printf("FreeRTOS Version: %s", tskKERNEL_VERSION_NUMBER);
    printf("SystemClock: %d\n", SystemCoreClock);

    xTaskCreate(TaskBlink, "task1", 256, NULL, 5, &hTaskBlink);
    vTaskStartScheduler();
}

void GPIO_User_Init(void) {
    GPIO_InitTypeDef gpio_init_struct = { 0 };
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    gpio_init_struct.GPIO_Pin = GPIO_Pin_0;
    gpio_init_struct.GPIO_Mode = GPIO_Mode_Out_PP;
    gpio_init_struct.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &gpio_init_struct);
}

void TaskBlink(void* pArgs) {
    while(1) {
        GPIO_WriteBit(GPIOA, GPIO_Pin_0, Bit_SET);
        uint8_t pin_a0_state = GPIO_ReadOutputDataBit(GPIOA, GPIO_Pin_0);
        printf("pin a0 state:%u\n", pin_a0_state);
        vTaskDelay(1000);
        GPIO_WriteBit(GPIOA, GPIO_Pin_0, Bit_RESET);
        pin_a0_state = GPIO_ReadOutputDataBit(GPIOA, GPIO_Pin_0);
        printf("pin a0 state:%u\n", pin_a0_state);
        vTaskDelay(1000);
    }
}
